class String
  def method_missing(method, *args)
    method == :ghost_reverse ? reverse : super
  end
end

require 'benchmark'
Benchmark.bmbm do |b|
  b.report 'Normal method' do
    1_000_000.times { "abc".reverse }
  end
  b.report 'Ghost method' do
    1_000_000.times { "abc".ghost_reverse }
  end
end
#        user     system      total        real
# Normal method  0.280000   0.000000   0.280000 (  0.276858)
# Ghost  method  0.580000   0.000000   0.580000 (  0.581901)
